/* Autogenerated file. Do not edit manually. */
/* tslint:disable */
/* eslint-disable */

import BN from "bn.js";
import { ContractOptions } from "web3-eth-contract";
import { EventLog } from "web3-core";
import { EventEmitter } from "events";
import {
  Callback,
  PayableTransactionObject,
  NonPayableTransactionObject,
  BlockType,
  ContractEventLog,
  BaseContract,
} from "./types";

interface EventOptions {
  filter?: object;
  fromBlock?: BlockType;
  topics?: string[];
}

export type MinterAdded = ContractEventLog<{
  account: string;
  0: string;
}>;
export type MinterRemoved = ContractEventLog<{
  account: string;
  0: string;
}>;
export type Paused = ContractEventLog<{
  account: string;
  0: string;
}>;
export type Unpaused = ContractEventLog<{
  account: string;
  0: string;
}>;
export type PauserAdded = ContractEventLog<{
  account: string;
  0: string;
}>;
export type PauserRemoved = ContractEventLog<{
  account: string;
  0: string;
}>;
export type Transfer = ContractEventLog<{
  from: string;
  to: string;
  value: string;
  0: string;
  1: string;
  2: string;
}>;
export type Approval = ContractEventLog<{
  owner: string;
  spender: string;
  value: string;
  0: string;
  1: string;
  2: string;
}>;

export interface JarvisRewardToken extends BaseContract {
  constructor(
    jsonInterface: any[],
    address?: string,
    options?: ContractOptions
  ): JarvisRewardToken;
  clone(): JarvisRewardToken;
  methods: {
    name(): NonPayableTransactionObject<string>;

    approve(
      spender: string,
      value: number | string | BN
    ): NonPayableTransactionObject<boolean>;

    /**
     * Total number of tokens in existence
     */
    totalSupply(): NonPayableTransactionObject<string>;

    transferFrom(
      from: string,
      to: string,
      value: number | string | BN
    ): NonPayableTransactionObject<boolean>;

    PERMIT_TYPEHASH(): NonPayableTransactionObject<string>;

    decimals(): NonPayableTransactionObject<string>;

    MAX_SUPPLY(): NonPayableTransactionObject<string>;

    DOMAIN_SEPARATOR(): NonPayableTransactionObject<string>;

    increaseAllowance(
      spender: string,
      addedValue: number | string | BN
    ): NonPayableTransactionObject<boolean>;

    /**
     * called by the owner to unpause, returns to normal state
     */
    unpause(): NonPayableTransactionObject<void>;

    /**
     * Function to mint tokens
     * @param to The address that will receive the minted tokens.
     * @param value The amount of tokens to mint.
     * @returns A boolean that indicates if the operation was successful.
     */
    mint(
      to: string,
      value: number | string | BN
    ): NonPayableTransactionObject<boolean>;

    /**
     * Burns a specific amount of tokens.
     * @param value The amount of token to be burned.
     */
    burn(value: number | string | BN): NonPayableTransactionObject<void>;

    isPauser(account: string): NonPayableTransactionObject<boolean>;

    /**
     * @returns true if the contract is paused, false otherwise.
     */
    paused(): NonPayableTransactionObject<boolean>;

    renouncePauser(): NonPayableTransactionObject<void>;

    /**
     * Gets the balance of the specified address.
     * @param owner The address to query the balance of.
     * @returns An uint256 representing the amount owned by the passed address.
     */
    balanceOf(owner: string): NonPayableTransactionObject<string>;

    /**
     * Burns a specific amount of tokens from the target address and decrements allowance
     * @param from address The address which you want to send tokens from
     * @param value uint256 The amount of token to be burned
     */
    burnFrom(
      from: string,
      value: number | string | BN
    ): NonPayableTransactionObject<void>;

    nonces(arg0: string): NonPayableTransactionObject<string>;

    addPauser(account: string): NonPayableTransactionObject<void>;

    /**
     * called by the owner to pause, triggers stopped state
     */
    pause(): NonPayableTransactionObject<void>;

    permit(
      holder: string,
      spender: string,
      nonce: number | string | BN,
      expiry: number | string | BN,
      allowed: boolean,
      v: number | string | BN,
      r: string | number[],
      s: string | number[]
    ): NonPayableTransactionObject<void>;

    symbol(): NonPayableTransactionObject<string>;

    addMinter(account: string): NonPayableTransactionObject<void>;

    renounceMinter(): NonPayableTransactionObject<void>;

    decreaseAllowance(
      spender: string,
      subtractedValue: number | string | BN
    ): NonPayableTransactionObject<boolean>;

    transfer(
      to: string,
      value: number | string | BN
    ): NonPayableTransactionObject<boolean>;

    isMinter(account: string): NonPayableTransactionObject<boolean>;

    /**
     * Function to check the amount of tokens that an owner allowed to a spender.
     * @param owner address The address which owns the funds.
     * @param spender address The address which will spend the funds.
     * @returns A uint256 specifying the amount of tokens still available for the spender.
     */
    allowance(
      owner: string,
      spender: string
    ): NonPayableTransactionObject<string>;

    upgradeToV2(
      chainId: number | string | BN,
      minter: string
    ): NonPayableTransactionObject<void>;

    transferToMany(
      _recipients: string[],
      _values: (number | string | BN)[]
    ): NonPayableTransactionObject<boolean>;
  };
  events: {
    MinterAdded(cb?: Callback<MinterAdded>): EventEmitter;
    MinterAdded(
      options?: EventOptions,
      cb?: Callback<MinterAdded>
    ): EventEmitter;

    MinterRemoved(cb?: Callback<MinterRemoved>): EventEmitter;
    MinterRemoved(
      options?: EventOptions,
      cb?: Callback<MinterRemoved>
    ): EventEmitter;

    Paused(cb?: Callback<Paused>): EventEmitter;
    Paused(options?: EventOptions, cb?: Callback<Paused>): EventEmitter;

    Unpaused(cb?: Callback<Unpaused>): EventEmitter;
    Unpaused(options?: EventOptions, cb?: Callback<Unpaused>): EventEmitter;

    PauserAdded(cb?: Callback<PauserAdded>): EventEmitter;
    PauserAdded(
      options?: EventOptions,
      cb?: Callback<PauserAdded>
    ): EventEmitter;

    PauserRemoved(cb?: Callback<PauserRemoved>): EventEmitter;
    PauserRemoved(
      options?: EventOptions,
      cb?: Callback<PauserRemoved>
    ): EventEmitter;

    Transfer(cb?: Callback<Transfer>): EventEmitter;
    Transfer(options?: EventOptions, cb?: Callback<Transfer>): EventEmitter;

    Approval(cb?: Callback<Approval>): EventEmitter;
    Approval(options?: EventOptions, cb?: Callback<Approval>): EventEmitter;

    allEvents(options?: EventOptions, cb?: Callback<EventLog>): EventEmitter;
  };

  once(event: "MinterAdded", cb: Callback<MinterAdded>): void;
  once(
    event: "MinterAdded",
    options: EventOptions,
    cb: Callback<MinterAdded>
  ): void;

  once(event: "MinterRemoved", cb: Callback<MinterRemoved>): void;
  once(
    event: "MinterRemoved",
    options: EventOptions,
    cb: Callback<MinterRemoved>
  ): void;

  once(event: "Paused", cb: Callback<Paused>): void;
  once(event: "Paused", options: EventOptions, cb: Callback<Paused>): void;

  once(event: "Unpaused", cb: Callback<Unpaused>): void;
  once(event: "Unpaused", options: EventOptions, cb: Callback<Unpaused>): void;

  once(event: "PauserAdded", cb: Callback<PauserAdded>): void;
  once(
    event: "PauserAdded",
    options: EventOptions,
    cb: Callback<PauserAdded>
  ): void;

  once(event: "PauserRemoved", cb: Callback<PauserRemoved>): void;
  once(
    event: "PauserRemoved",
    options: EventOptions,
    cb: Callback<PauserRemoved>
  ): void;

  once(event: "Transfer", cb: Callback<Transfer>): void;
  once(event: "Transfer", options: EventOptions, cb: Callback<Transfer>): void;

  once(event: "Approval", cb: Callback<Approval>): void;
  once(event: "Approval", options: EventOptions, cb: Callback<Approval>): void;
}
